// Composables
import { provideDefaults } from "../../composables/defaults.mjs"; // Utilities
import { toRefs } from 'vue';
import { genericComponent } from "../../util/index.mjs"; // Types
export const VDefaultsProvider = genericComponent(false)({
  name: 'VDefaultsProvider',
  props: {
    defaults: Object,
    reset: [Number, String],
    root: Boolean,
    scoped: Boolean
  },
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    const {
      defaults,
      reset,
      root,
      scoped
    } = toRefs(props);
    provideDefaults(defaults, {
      reset,
      root,
      scoped
    });
    return () => slots.default?.();
  }
});
//# sourceMappingURL=VDefaultsProvider.mjs.map